/*
 * boom.c - BOOM, main function
 *
 * Copyright 2012 by Werner Almesberger
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>

#include "lang.h"


static void open_stdin(const char *name)
{
	int fd;

	fd = open(name, O_RDONLY);
	if (fd < 0) {
		perror(name);
		exit(1);
	}
	if (dup2(fd, 0) < 0) {
		perror("dup2");
		exit(1);
	}
}


static void usage(const char *name)
{
	fprintf(stderr, "usage: %s [file ...]\n", name);
	exit(1);
}


int main(int argc, char **argv)
{
	int i;

	switch (argc) {
	case 1:
		break;
	default:
		open_stdin(argv[1]);
		break;
	}
	parse_hierarchy();
	for (i = 2; i < argc; i++) {
		open_stdin(argv[i]);
		parse_characteristics();
	}
	return 0;
}
